'use strict';

var path = require('path');
var webpack = require('webpack');
var ExtractTextPlugin = require('extract-text-webpack-plugin');
var assign = require('object-assign');


module.exports = function(args) {

  var plugins = [
    new webpack.optimize.OccurenceOrderPlugin(),
    new webpack.IgnorePlugin(/^xhr2$/),
    new webpack.IgnorePlugin(/\.\/lib\/\.$/)
  ];

  if (args.css) {
    plugins.push(new ExtractTextPlugin('[name].css',{allChunks:true}));
  }

  if (!args.debug) {
    plugins.push(new webpack.optimize.UglifyJsPlugin({
      output: {
        ascii_only: true
      }
    }));
  }

  var common = require('./webpack.common.config')(args.globalConfig,args.css);

  if (args.debug) {
    common.module.loaders.unshift(
      {
        test: /\.html$/,
        loader: 'thtml'
      },     
      {
        test: /\.jsx?$/,
        exclude: /node_modules/,
        loader: 'babel'
      }
    );
  } else {
    common.module.loaders.unshift(
      {
        test: /\.html$/,
        loader: 'thtml-minifier'
      },     
      {
        test: /\.jsx?$/,
        exclude: /node_modules/,
        loader: 'strip?strip[]=debugger,strip[]=console.log!babel'
      }
    );
  }
  
  return assign({}, common, {
    plugins: plugins,
  });
};
