'use strict';

var path = require('path');
var webpack = require('webpack');
var ExtractTextPlugin = require('extract-text-webpack-plugin');
var assign = require('object-assign');

module.exports = function(args) {
  var plugins = [
    new webpack.HotModuleReplacementPlugin(),
    new webpack.NoErrorsPlugin(),
    new webpack.optimize.OccurenceOrderPlugin(),
    new webpack.IgnorePlugin(/^xhr2$/),
    new webpack.IgnorePlugin(/\.\/lib\/\.$/),
//    new webpack.optimize.CommonsChunkPlugin({name: "m/common"})
  ];

  if (args.css) {
    plugins.push(new ExtractTextPlugin('[name].css',{allChunks:true}));
  }

  var common = require('./webpack.common.config')(args.globalConfig,args.css);
  common.module.loaders.unshift(
  {
    test: /\.html$/,
    loader: 'thtml'
  },     
  {
    test: /\.jsx?$/,
    exclude: /node_modules/,
    loader: 'babel'
  }
  );

  return assign({}, common, {
    devtool: '#source-map',
    plugins: plugins
  });
};